? part_diff.txt
Index: src/backend/catalog/Makefile
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/catalog/Makefile,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.10.1
diff -c -r1.1.1.2 -r1.1.1.2.10.1
*** src/backend/catalog/Makefile	1 Dec 2008 09:37:46 -0000	1.1.1.2
--- src/backend/catalog/Makefile	10 Feb 2009 13:18:07 -0000	1.1.1.2.10.1
***************
*** 27,33 ****
  
  POSTGRES_BKI_SRCS = $(addprefix $(top_srcdir)/src/include/catalog/,\
  	pg_proc.h pg_type.h pg_attribute.h pg_class.h pg_autovacuum.h \
! 	pg_attrdef.h pg_constraint.h pg_inherits.h pg_index.h pg_operator.h \
  	pg_opfamily.h pg_opclass.h pg_am.h pg_amop.h pg_amproc.h \
  	pg_language.h pg_largeobject.h pg_aggregate.h pg_statistic.h \
  	pg_rewrite.h pg_trigger.h pg_listener.h pg_description.h pg_cast.h \
--- 27,33 ----
  
  POSTGRES_BKI_SRCS = $(addprefix $(top_srcdir)/src/include/catalog/,\
  	pg_proc.h pg_type.h pg_attribute.h pg_class.h pg_autovacuum.h \
! 	pg_attrdef.h pg_constraint.h pg_inherits.h pg_partition.h pg_index.h pg_operator.h \
  	pg_opfamily.h pg_opclass.h pg_am.h pg_amop.h pg_amproc.h \
  	pg_language.h pg_largeobject.h pg_aggregate.h pg_statistic.h \
  	pg_rewrite.h pg_trigger.h pg_listener.h pg_description.h pg_cast.h \
Index: src/backend/catalog/pg_operator.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/catalog/pg_operator.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.10.1
diff -c -r1.1.1.1 -r1.1.1.1.10.1
*** src/backend/catalog/pg_operator.c	1 Dec 2008 09:36:26 -0000	1.1.1.1
--- src/backend/catalog/pg_operator.c	19 Feb 2009 11:51:17 -0000	1.1.1.1.10.1
***************
*** 35,41 ****
  #include "utils/syscache.h"
  
  
! static Oid OperatorGet(const char *operatorName,
  			Oid operatorNamespace,
  			Oid leftObjectId,
  			Oid rightObjectId,
--- 35,41 ----
  #include "utils/syscache.h"
  
  
! Oid OperatorGet(const char *operatorName,
  			Oid operatorNamespace,
  			Oid leftObjectId,
  			Oid rightObjectId,
***************
*** 127,133 ****
   *
   *		*defined is set TRUE if defined (not a shell)
   */
! static Oid
  OperatorGet(const char *operatorName,
  			Oid operatorNamespace,
  			Oid leftObjectId,
--- 127,133 ----
   *
   *		*defined is set TRUE if defined (not a shell)
   */
! Oid
  OperatorGet(const char *operatorName,
  			Oid operatorNamespace,
  			Oid leftObjectId,
Index: src/backend/commands/tablecmds.c
===================================================================
RCS file: /mart/pgsql_home/pgrepo/pgsql_init/src/backend/commands/tablecmds.c,v
retrieving revision 1.1.1.2
retrieving revision 1.1.1.2.8.22
diff -c -r1.1.1.2 -r1.1.1.2.8.22
*** src/backend/commands/tablecmds.c	1 Dec 2008 09:37:46 -0000	1.1.1.2
--- src/backend/commands/tablecmds.c	19 Mar 2009 12:34:56 -0000	1.1.1.2.8.22
***************
*** 49,54 ****
--- 49,55 ----
  #include "nodes/makefuncs.h"
  #include "nodes/nodeFuncs.h"
  #include "nodes/parsenodes.h"
+ #include "nodes/pg_list.h"
  #include "optimizer/clauses.h"
  #include "optimizer/plancat.h"
  #include "optimizer/prep.h"
***************
*** 76,82 ****
--- 77,96 ----
  #include "utils/snapmgr.h"
  #include "utils/syscache.h"
  #include "utils/tqual.h"
+ #include "tcop/tcopprot.h"
+ #include "utils/numeric.h"
  
+ /* For partitions */
+ #include "catalog/pg_partition.h"
+ #include "catalog/pg_operator.h"
+ #include "postgres.h"
+ #include "executor/spi.h"
+ #include "commands/trigger.h"
+ #include "utils/rel.h"
+ 
+ extern Datum trigf(PG_FUNCTION_ARGS);
+ 
+ PG_FUNCTION_INFO_V1(trigf);
  
  /*
   * ON COMMIT action list
***************
*** 97,102 ****
--- 111,123 ----
  	SubTransactionId deleting_subid;
  } OnCommitItem;
  
+ 
+ typedef struct PartitionRowInfo
+ {
+     ItemPointerData tid;
+     Oid             partRelOid;
+ }PartitionRowInfo;
+ 
  static List *on_commits = NIL;
  
  
***************
*** 114,130 ****
   * a pass determined by subcommand type.
   */
  
! #define AT_PASS_DROP			0		/* DROP (all flavors) */
! #define AT_PASS_ALTER_TYPE		1		/* ALTER COLUMN TYPE */
! #define AT_PASS_OLD_INDEX		2		/* re-add existing indexes */
! #define AT_PASS_OLD_CONSTR		3		/* re-add existing constraints */
! #define AT_PASS_COL_ATTRS		4		/* set other column attributes */
  /* We could support a RENAME COLUMN pass here, but not currently used */
! #define AT_PASS_ADD_COL			5		/* ADD COLUMN */
! #define AT_PASS_ADD_INDEX		6		/* ADD indexes */
! #define AT_PASS_ADD_CONSTR		7		/* ADD constraints, defaults */
! #define AT_PASS_MISC			8		/* other stuff */
! #define AT_NUM_PASSES			9
  
  typedef struct AlteredTableInfo
  {
--- 135,156 ----
   * a pass determined by subcommand type.
   */
  
! #define AT_PASS_DROP					0		/* DROP (all flavors) */
! #define AT_PASS_ALTER_TYPE				1		/* ALTER COLUMN TYPE */
! #define AT_PASS_OLD_INDEX				2		/* re-add existing indexes */
! #define AT_PASS_OLD_CONSTR				3		/* re-add existing constraints */
! #define AT_PASS_COL_ATTRS				4		/* set other column attributes */
  /* We could support a RENAME COLUMN pass here, but not currently used */
! #define AT_PASS_ADD_COL					5		/* ADD COLUMN */
! #define AT_PASS_ADD_INDEX				6		/* ADD indexes */
! #define AT_PASS_ADD_CONSTR				7		/* ADD constraints, defaults */
! #define AT_PASS_ADD_PARTITION   		8		/* ADD partition to an existing table. */
! #define AT_PASS_DROP_PARTITION_NAME 	9   	/* DROP partition(By name) of an existing table */
! #define AT_PASS_DROP_PARTITION_RANGE 	10		/* DROP partition(By range) of an existing table */
! #define AT_PASS_UPDATE_PARTITION		11		/* UPDATE range partition. */
! #define AT_PASS_SPLIT_PARTITION			12		/* SPLIT range partition. */
! #define AT_PASS_MISC					13		/* other stuff */
! #define AT_NUM_PASSES					14
  
  typedef struct AlteredTableInfo
  {
***************
*** 322,329 ****
  static void ATExecDropInherit(Relation rel, RangeVar *parent);
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  							   ForkNumber forkNum, bool istemp);
! 
! 
  /* ----------------------------------------------------------------
   *		DefineRelation
   *				Creates a new relation.
--- 348,371 ----
  static void ATExecDropInherit(Relation rel, RangeVar *parent);
  static void copy_relation_data(SMgrRelation rel, SMgrRelation dst,
  							   ForkNumber forkNum, bool istemp);
! static void CreatePartitionTrigger(CreateStmt *stmt, Oid parentRelOid, Oid *partitionRelOids);
! static void MutateColumnRefs(Node *node, char *reference);
! Oid OperatorGet(const char *operatorName,
!             Oid operatorNamespace,
!             Oid leftObjectId,
!             Oid rightObjectId,
!             bool *defined);
! static Oid ATExecAddPartition(AlteredTableInfo *tab, Relation rel,
! 				Partition *part); /* Adding partition to an existing table. */
! static void ATExecDropPartitionByName(AlteredTableInfo *tab, Relation rel,
! 				Partition *part); /* Deleting partition of an existing table by name. */
! static void ATExecDropPartitionByRange(AlteredTableInfo *tab, Relation rel,
! 				Partition *part); /* Deleting partition of an existing table by Range. */
! static void ATExecUpdatePartition(AlteredTableInfo *tab, Relation rel,
! 				UpdatePartitionStmt *part); /* Deleting partition of an existing table by Range. */
! static void ATExecSplitPartition(AlteredTableInfo *tab, Relation rel,
! 				SplitPartitionStmt *part); /* Splitting partition of an existing table. */
! Oid get_relevent_partition(HeapTuple tuple, Relation rel);
  /* ----------------------------------------------------------------
   *		DefineRelation
   *				Creates a new relation.
***************
*** 2170,2175 ****
--- 2212,2297 ----
  						stmt, RelationGetRelationName(rel))));
  }
  
+ 
+ /*
+  * GetPartitionsCountAtt : Check if given table is a partitioned table and there 
+  * exists atleast one partition(s) for specified partition key column.
+  */
+ int GetPartitionsCount(Oid parentOid)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	int			partitions;
+ 
+ 	partitions = 0;
+ 	
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 		
+ 		if(pg_part->keyorder == 1)
+ 			partitions++;
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitions;
+ } 
+ 
+ /*
+  * GetPartitionsCountAtt : Check if given table is a partitioned table and there 
+  * exists atleast one partition(s) for specified partition key column.
+  */
+ int GetPartitionsCountAtt(Oid parentOid, Oid attNum)
+ {
+ 	ScanKeyData skey;
+ 	Relation    pg_partrel;
+ 	SysScanDesc pg_partscan;
+ 	HeapTuple   pg_parttup;
+ 	int			partitions;
+ 
+ 	partitions = 0;
+ 	
+     /*Scan key to scan pg_partition table on parentrelid*/
+     ScanKeyInit(&skey,
+                 Anum_pg_partition_parentrelid,
+                 BTEqualStrategyNumber, F_OIDEQ,
+                 ObjectIdGetDatum(parentOid));
+ 
+     pg_partrel = heap_open(PartitionRelationId, AccessShareLock);
+     pg_partscan = systable_beginscan(pg_partrel, PartitionParentIndexId, true,
+                                 SnapshotNow, 1, &skey);
+ 
+     while (HeapTupleIsValid(pg_parttup= systable_getnext(pg_partscan)))
+ 	{
+         /* Instead of pg_part Use heap_getattr for accessing bytea coluns */
+         Form_pg_partition pg_part = (Form_pg_partition) GETSTRUCT(pg_parttup);
+ 
+ 		if(pg_part->partkey == attNum)
+ 			partitions++;
+ 	}
+ 
+ 	systable_endscan(pg_partscan);
+ 	heap_close(pg_partrel, AccessShareLock);
+ 
+ 	return partitions;
+ } 
+ 
+ 
  /*
   * AlterTable
   *		Execute ALTER TABLE, which can be a list of subcommands
***************
*** 2328,2333 ****
--- 2450,2459 ----
  	 */
  	switch (cmd->subtype)
  	{
+ 		case AT_AddPartition:	/* Add partition to an existing table. */
+ 			ATSimplePermissions(rel, false);
+ 			pass = AT_PASS_ADD_PARTITION;	
+ 			break;
  		case AT_AddColumn:		/* ADD COLUMN */
  			ATSimplePermissions(rel, false);
  			/* Performs own recursion */
***************
*** 2347,2352 ****
--- 2473,2494 ----
  			/* No command-specific prep needed */
  			pass = cmd->def ? AT_PASS_ADD_CONSTR : AT_PASS_DROP;
  			break;
+ 		case AT_DropPartitionByName: /* Drop partition by Name.*/
+ 			ATSimplePermissions(rel, false);
+ 			pass = AT_PASS_DROP_PARTITION_NAME;	
+ 			break;
+ 		case AT_DropPartitionByRange: /* Drop partition by Range*/
+ 			ATSimplePermissions(rel, false);
+ 			pass = AT_PASS_DROP_PARTITION_RANGE;	
+ 			break;
+ 		case AT_UpdatePartition: /* */
+ 			ATSimplePermissions(rel, false);
+ 			pass = AT_PASS_UPDATE_PARTITION;
+ 			break;
+ 		case AT_SplitPartition: /* */
+ 			ATSimplePermissions(rel, false);
+ 			pass = AT_PASS_SPLIT_PARTITION;
+ 			break;
  		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
  			ATSimplePermissions(rel, false);
  			ATSimpleRecursion(wqueue, rel, cmd, recurse);
***************
*** 2554,2565 ****
--- 2696,2722 ----
  {
  	switch (cmd->subtype)
  	{
+ 		case AT_AddPartition:   /* Add partition to an existing table. */
+ 			ATExecAddPartition(tab, rel, (Partition *)cmd->def);
+ 			break;
  		case AT_AddColumn:		/* ADD COLUMN */
  			ATExecAddColumn(tab, rel, (ColumnDef *) cmd->def);
  			break;
  		case AT_ColumnDefault:	/* ALTER COLUMN DEFAULT */
  			ATExecColumnDefault(rel, cmd->name, cmd->def);
  			break;
+ 		case AT_DropPartitionByName:	/* DROP partition(by name) of an existing table.*/
+ 			ATExecDropPartitionByName(tab, rel, (Partition *)cmd->def);
+ 			break;
+ 		case AT_DropPartitionByRange:	/* DROP partition(by range) of an existing table.*/
+ 			ATExecDropPartitionByRange(tab, rel, (Partition *)cmd->def);
+ 			break;
+ 		case AT_UpdatePartition: /* Update Range partition.*/
+ 			ATExecUpdatePartition(tab, rel, (UpdatePartitionStmt *)cmd->def);
+ 			break;
+ 		case AT_SplitPartition: /* Update Range partition.*/
+ 			ATExecSplitPartition(tab, rel, (SplitPartitionStmt *)cmd->def);
+ 			break;
  		case AT_DropNotNull:	/* ALTER COLUMN DROP NOT NULL */
  			ATExecDropNotNull(rel, cmd->name);
  			break;
